#ifndef FPS
#define FPS

/*
  Frames-per-second timer
  author:  Scott Scriven (scriven@vis.colostate.edu)
*/

#include <sys/time.h>
#include <stdio.h>


unsigned int frames = 0;
//time_t begin, fini;
//clock_t begin, fini;
struct timeval begin, fini;

void FpsStart();
void FpsEnd();
void ShowFps();
float Fps();
float Seconds();


void FpsStart()
{
   //begin = gettimeofday();
   //begin = clock();
   gettimeofday(&begin, 0);
   frames = 0;
}

void FpsEnd()
{
   //fini = gettimeofday();
   //fini = clock();
   gettimeofday(&fini, 0);
}


void ShowFps()
{
   float fps, seconds;
   
   fps = Fps();
   //seconds = 0;
   seconds = Seconds();

   if(fps > 0)
   {
      printf("\nFrames : %i", frames);
      //printf("\nSeconds: %f", (float)(fini-begin)/CLOCKS_PER_SEC);
      printf("\nSeconds: %f", seconds);
      printf("\nFPS    : %f\n", Fps());
      //printf("Note:  This FPS calculation is broken.\n");
   }
}

float Seconds()
{
   #define TICKS_PER_SEC 1000000
   float elapsed;
   int fusec, busec;

   // Adjust usecs so that fini > begin
   fusec = fini.tv_usec;
   busec = begin.tv_usec;
   if(busec > fusec)
   {
      busec -= TICKS_PER_SEC;
   }
   
   //elapsed = difftime(begin, fini);
   //printf("Elapsed: %f\n", elapsed);
   elapsed = (fini.tv_sec - begin.tv_sec)
     + ((float)(fusec - busec) / TICKS_PER_SEC);
   //elapsed = fini - begin;
   
   return elapsed;
}

float Fps()
{
   double rate;
   double elapsed;
   
   elapsed = Seconds();
   
   //FpsEnd();

   if(elapsed <= 0) return 0;
   //rate = ((float)frames / (float)(elapsed)*CLOCKS_PER_SEC);
   rate = ((float)frames / (float)(elapsed));

   return (float)rate;
}

#endif


#if 0

<jrray> #include <sys/time.h>
<jrray> #include <unistd.h>
<jrray>  
<jrray> int main() {
<jrray>  
<jrray>         struct timeval time1;
<jrray>         int now;
<jrray>  
<jrray>         now = time(NULL);
<jrray>         while (time(NULL) == now) {
<jrray>                 gettimeofday(&time1, 0);
<jrray>                 printf("%10ld %10ld\n", time1.tv_sec, time1.tv_usec);
<jrray>         }
<jrray>  
<jrray>         return 0;
<jrray> }                                                                                                                                                                               
<jrray> sample output:
<jrray>  984983840     910610
<jrray>  984983840     910620
<jrray>  984983840     910630
<jrray>  984983840     910640
<jrray>  984983840     910650                                                                                                                                                           
<jrray>   ^ seconds (since epoch) ^ microseconds into second

#endif
